c ======================================================================
c To be used with tricks.f, vers 1
c ======================================================================
      SUBROUTINE READINPUT(EPS,HMAX,NXSTEP)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'
      CHARACTER*8  SUB

c Read parameters from 'gg_control.d'===================================
      READ (NCON,10)
      READ (NCON,12) IDUST
      READ (NCON,12) ISELF
      READ (NCON,12) ITASK
      READ (NCON,11)
      READ (NCON,14) DENS
      READ (NCON,14) TEMP
      READ (NCON,14) AV
      READ (NCON,14) CDH2
      READ (NCON,14) CDCO
      READ (NCON,14) ZETA
      READ (NCON,14) UVFAC
      READ (NCON,11)
      READ (NCON,14) DTEMP
      READ (NCON,14) EBFAC
      READ (NCON,14) DTOGM
      READ (NCON,14) STICK
      READ (NCON,14) RHOD
      READ (NCON,14) RD
      READ (NCON,14) SNS
      READ (NCON,14) TNS
      READ (NCON,11)
      READ (NCON,13) OTPD
      READ (NCON,14) TSTART
      READ (NCON,14) TFINAL
      READ (NCON,11)
      READ (NCON,14) EPS
      READ (NCON,14) YMIN
      READ (NCON,14) HMAX
      READ (NCON,13) NXSTEP
      READ (NCON,11) 
      READ (NCON,14) XNMIN
      READ (NCON,13) NS0
      READ (NCON,*) 
      READ (NCON,15) (XS0(I),XN0(I),I=1,NS0)
   10 FORMAT (//////)
   11 FORMAT (//)
   12 FORMAT (21X,I2)
   13 FORMAT (10X,I14)
   14 FORMAT (10X,E14.7)
   15 FORMAT (A8,2X,E14.7)

      TSTART=TSTART*TYEAR
      TFINAL=TFINAL*TYEAR
      HMAX=HMAX*TYEAR
      GD=(4.D+0*PI*RHOD*RD*RD*RD)/(3.D+0*DTOGM*AMU)


c Read species & reaction info from reactions file======================
      READ (NJR,70) (ELNAME(K),K=1,NEMAX)
   70    FORMAT (12X,20(1X,A2))
      DO K=1,NEMAX
         IF (ELNAME(K)(1:1).EQ.' ') THEN
            SUB=ELNAME(K)(2:2)
         ELSE
            SUB=ELNAME(K)(1:2)
         ENDIF
         ELNAME(K)=SUB
      ENDDO
      DO I=1,NSMAX
         READ (NJR,80) SPEC(I),ICG(I),(IELM(K,I),K=1,NEMAX)
   80    FORMAT (A8,2X,I2,13(1X,I2))
      ENDDO

      DO J=1,NKMAX
         READ (NJR,90) (RSPEC(I,J),I=1,8),A(J),B(J),C(J),
     1              ITYPE(J),INUM(J)
      ENDDO
   90 FORMAT (8A8,3E9.2,2X,I2,2X,I5)


c Write special RSPECs for ORDER file==================================
      DO J=1,NKMAX
         SYM2(J)='    '
         IF (ITYPE(J).EQ.1)  SYM2(J)='CR  '
         IF (ITYPE(J).EQ.13) SYM2(J)='UV  '
         IF (ITYPE(J).EQ.14) SYM2(J)='L-H '
         IF (ITYPE(J).EQ.15) SYM2(J)='des.'
         IF (ITYPE(J).EQ.99) SYM2(J)='ads.'
      ENDDO

      RETURN
      END
      
c ======================================================================
c ======================================================================
      SUBROUTINE WRITEHEAD(EPS,HMAX,NXSTEP)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'

      CHARACTER*12 KDUST,KSELF,KTASK

c Write parameter information===========================================
      CALL WRITENAME(NOUT)

c --- Write switch information
      KDUST='NO'
      IF (IDUST.EQ.1) KDUST='YES'
      IF (IDUST.EQ.2) KDUST='YES, JH+JH'

      KSELF='NO'
      IF (ISELF.EQ.1) KSELF='YES'

      IF (ITASK.EQ.1) KTASK='INTERP'
      IF (ITASK.EQ.2) KTASK='OH DEAR!'
      IF (ITASK.EQ.3) KTASK='EXACT'

      WRITE (NOUT,110) KDUST,IDUST
  110 FORMAT (28X,'DEPLETION OF GAS ONTO DUST GRAINS: ',
     1    A12,' (IDUST=',I2,')')

      WRITE (NOUT,120) KSELF,ISELF
  120 FORMAT (31X,'DO SELF-SHIELDING CALCULATIONS: ',
     1    A12,' (ISELF=',I2,')')

      WRITE (NOUT,126) KTASK,ITASK
  126 FORMAT (22X,'INTEGRATOR METHOD FOR REACHING O/P TIME: ',
     1    A12,' (ITASK=',I2,')' )

c --- Write ODE information
      WRITE (NOUT,130) NSMAX,NSGAS,NSGRAIN,NKMAX,NEMAX
  130 FORMAT (/26X,'NUMBER OF CHEMICAL SPECIES,',3X,'NSMAX =',I7
     1 /25X,'NUMBER OF GAS PHASE SPECIES,',3X,'NSGAS =',I7
     2 /29X,'NUMBER OF GRAIN SPECIES,',1X,'NSGRAIN =',I7
     3 /24X,'NUMBER OF CHEMICAL REACTIONS,',3X,'NKMAX =',I7
     4 /34X,'NUMBER OF ELEMENTS,',3X,'NEMAX =',I7)

c --- Write gas phase information
      WRITE (NOUT,140) DENS,TEMP,AV
  140 FORMAT(/25X,'TOTAL NUMBER DENSITY OF GAS,',
     1   4X,'DENS = ',1PE10.3,' cm-3'
     2 /29X,'GAS KINETIC TEMPERATURE,',
     3   4X,'TEMP = ',1PE10.3,' K'
     4 /26X,'VISUAL EXTINCTION OF CLOUD,',6X,'AV = ',1PE10.3)

      WRITE (NOUT,145) CDH2,CDCO,ZETA,UVFAC
  145 FORMAT(
     1  35X,'H2 COLUMN DENSITY,',4X,'CDH2 = ',1PE10.3,' cm-2'
     2 /35X,'CO COLUMN DENSITY,',4X,'CDCO = ',1PE10.3,' cm-2'
     3 /26X,'COSMIC-RAY IONIZATION RATE,',4X,'ZETA = ',1PE10.3,' s-1'
     4 /17X,'SCALE FACTOR FOR UV RADIATION FIELD,',3X,'UVFAC = ',
     5    1PE10.3)

c --- Write dust grain information
      WRITE (NOUT,160) DTOGM,GD
  160 FORMAT(/25X,'DUST TO GAS RATIO (BY MASS),',3X,'DTOGM = ',1PE10.3
     1 /23X,'GAS TO DUST RATIO (BY NUMBER),',
     2   6X,'GD = ',1PE10.3)

      WRITE (NOUT,170) STICK
  170 FORMAT(12X,'STICKING COEFFICIENT FOR NEUTRAL SPECIES,',
     1    3X,'STICK = ',1PE10.3)

      WRITE (NOUT,180) RD,RHOD,SNS,TNS,EBFAC
  180 FORMAT(32X,'RADIUS OF DUST GRAIN,',6X,'RD = ',1PE10.3,' cm'
     1 /27X,'DENSITY OF GRAIN MATERIAL,',4X,'RHOD = ',1PE10.3,' g.cm-3'
     2 /26X,'GRAIN SURFACE SITE DENSITY,',5X,'SNS = ',1PE10.3,' cm-2'
     3 /27X,'NUMBER OF SITES PER GRAIN,',5X,'TNS = ',1PE10.3
     4 /21X,'H + H --> H2: RATIO Eb(I):Ed(I),',3X,'EBFAC =',0PF7.3)

c --- Write initial abundance, species information
      WRITE (NOUT,240) XNMIN,NS0
  240 FORMAT (/8X,'DEFAULT MINIMUM INITIAL FRACTIONAL ABUNDANCE,',
     1 3X,'XNMIN = ',1PE10.3
     2 /14X,'NUMBER OF SPECIFIED INITIAL ABUNDANCES,',
     3 5X,'NS0 =',I4)

c --- Write integrator parameters
      WRITE (NOUT,250) EPS,YMIN,HMAX/TYEAR,NXSTEP
 250  FORMAT (/23X,'RELATIVE ACCURACY IN SOLUTION, ',
     1    4X,'EPS = ',1PE10.3
     2 /3X,'SMALLEST PHYSICALLY MEANINGFUL VALUE FOR SOLUTION,',
     3    5X,'EWT = ',1PE10.3,
     4 /22X,'MAXIMUM MAGNITUDE OF STEP SIZE,',
     5    4X,'HMAX = ',1PE10.3,' yr'
     6 /19X,'MAXIMUM NUMBER OF CALLS TO SDRIV3,',2X,'NXSTEP =  ',I9)

c --- Write output time information
      WRITE (NOUT,230) TSTART/TYEAR,TFINAL/TYEAR,OTPD,NT
  230 FORMAT (/32X,'TIME OF FIRST DECADE,',2X,'TSTART = ',1PE10.3,' yr'
     1 /29X,'FINAL TIME OF EVOLUTION,',2X,'TFINAL = ',1PE10.3,' yr'
     2 /24X,'NUMBER OF OUTPUTS PER DECADE,',4X,'OTPD = ',I3
     3 /35X,'NUMBER OF OUTPUTS,',6X,'NT = ',I4/)

c --- Write integrator information to 'top_intinfo.d'
      WRITE (NINF,395)
  395 FORMAT (/30X,'PARAMETERS IN NUMERICAL SOLUTION',
     1 //4X,'IT', 
     2 4X,'TIME',6X,'STEPS',3X,'FCHEM',4X,'JAC',3X,'ORDER(L)'/)

      RETURN
      END

c ======================================================================
c ======================================================================
      SUBROUTINE WRITEUPDATE
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'

c --- Write rates output
c     Write rates for first non-zero time only
c      IF (IT.EQ.2) THEN
c     Write rates for a chosen time only
      IF (IT.EQ.42) THEN
c     Write rates for all times greater than 10^4 yr
c      IF (TIMS(IT)/TYEAR/0.999D0.GE.1.D+04) THEN

         WRITE (NRAT,*)
         WRITE (NRAT,500) 'IT=',IT,'t=',TIMS(IT)/TYEAR,'yr'
  500 FORMAT(A3,1X,I4,6X,A2,1PE12.4,1X,A2)
         WRITE (NRAT,550)
  550 FORMAT (/1X,'REACTANTS',7X,'PRODUCTS',28X,' R(J)',
     1 8X,'k(J)',8X,'A(J)',8X,'B(J)',8X,'C(J)',5X,'ITYPE',7X,'J')
         DO J=1,NKMAX 
            WRITE (NRAT,560) (RSPEC(K,J),K=1,2),(RSPEC(K,J),K=4,7),
     1         R(J),XK(J),A(J),B(J),C(J),ITYPE(J),J
  560 FORMAT(1X,6A8,5(1PE12.4),5X,I2,(2X,'*',I5,'*'))
         ENDDO
         WRITE (NRAT,570)
  570 FORMAT (118('-'))
      ENDIF

c --- Write integrator information to 'top_intinfo.d'
      IF (IT.GT.1) THEN
         WRITE (NINF,735) IT,TIMS(IT)/TYEAR,(IEQP(J),J=2,4),IEQP(1)
  735    FORMAT (1X,I5,1X,1PE10.3,1X,I7,1X,I7,1X,I6,3X,I2) 
      ENDIF

      RETURN
      END

c ======================================================================
c ======================================================================
      SUBROUTINE OUTPUT
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'
      REAL*8 TIMY(NOPMAX)
      REAL*8 XNMAX(NSMAX)
 
      DO J=1,NT
         TIMY(J)=TIMS(J)/TYEAR
      ENDDO 

c --- Find maximum abundance values
      DO I=1,NSMAX
         XNMAX(I)=0.Q0
         DO J=1,NT
            IF (XNOP(I,J).GT.XNMAX(I)) XNMAX(I)=XNOP(I,J)
         ENDDO
      ENDDO

c Write abundances======================================================
      DO I=1,NSMAX,10
         L1=I
         L2=I+9
         IF (L2.GT.NSMAX) L2=NSMAX

         WRITE (NOUT,101)
  101 FORMAT (/40X,'TIME EVOLUTION OF FRACTIONAL ABUNDANCE')
         WRITE (NOUT,111) (SPEC(IS),IS=L1,L2)
  111 FORMAT (/3X,'IT',5X,'t(yr)',6X,10(A8,2X))
         DO J=1,NT
            WRITE (NOUT,121) J,TIMY(J),(XNOP(IS,J),IS=L1,L2)
  121 FORMAT (I5,1PE13.6,1X,10(1PE10.3E2))
         ENDDO
      ENDDO

c Write abundances in CSV format========================================
      DO I=1,NSMAX,10
         L1=I
         L2=I+9
         IF (L2.GT.NSMAX) L2=NSMAX

         WRITE (NCSV,211) (SPEC(IS),IS=L1,L2)
  211 FORMAT (/'IT,t(yr),',10(A8,','))
         DO J=1,NT
            WRITE (NCSV,221) J,TIMY(J),(XNOP(IS,J),IS=L1,L2)
  221 FORMAT (I5,',',1PE13.6,',',10(1PE10.3E2,','))
         ENDDO
      ENDDO

c Write abundances logarithmically in CSV format========================
      DO I=1,NSMAX,10
         L1=I
         L2=I+9
         IF (L2.GT.NSMAX) L2=NSMAX

         WRITE (NLOG,301)
  301 FORMAT (/,',',11('Log,'))
         WRITE (NLOG,311) (SPEC(IS),IS=L1,L2)
  311 FORMAT ('IT,t(yr),',10(A8,','))
         DO J=2,NT
            WRITE (NLOG,321) J,DLOG10(TIMY(J)),
     1                       (DLOG10(XNOP(IS,J)),IS=L1,L2)
  321 FORMAT (I5,',',1PE13.6,',',10(1PE10.3E2,','))
         ENDDO
      ENDDO

c Write final composition===============================================
      WRITE (NOUT,501)
      WRITE (NOUT,502)
      WRITE (NOUT,503) (SPEC(I),XNOP(I,1),XNMAX(I),XNOP(I,NT),I=1,NSMAX)
  501 FORMAT (/32X,'FINAL CHEMICAL COMPOSITION OF CLOUD MODEL'/)
  502 FORMAT (2(2X,'SPECIES',4X,'INITIAL',6X,'MAXIMUM',7X,'FINAL',5X))
  503 FORMAT (2(2X,A8,1X,1PE10.3E2,3X,1PE10.3E2,3X,1PE10.3E2,3X))

c Output integrator and conservation information========================
      WRITE (NINF,601) ISUMS,ISUMF,ISUMJ 
  601 FORMAT (/12X,'TOTAL',1X,I7,1X,I7,1X,I6) 


      RETURN 
      END 

c ======================================================================
c ======================================================================
      SUBROUTINE ORDER
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'

      REAL*8 DEST(NKMAX),PROD(NKMAX),PPC(NKMAX),DPC(NKMAX)
      REAL*8 DXDTP(NSMAX),DXDTN(NSMAX)
      INTEGER PLACED(NKMAX),PLACEP(NKMAX),RXND(NKMAX),RXNP(NKMAX)

c Calculate loss/gain rates of species==================================
      CALL RATCON(XN)
      CALL RATSIGN(XN,DXDTP,DXDTN)

c NB: Ignores species in slots #3 & #8 in output, 
c     since there are none in active reactions
      WRITE(NORD,340)
      WRITE(NORD,305) IT,TIME/TYEAR
  305 FORMAT (1X,'MOST IMPORTANT REACTIONS',
     1 ', IT = ',I5,', TIME =',1PE10.3,' yr')
      WRITE(NORD,340)

c --- Calculate loss/gain rates of species
c --- Cycle species
      DO I=1,NSMAX
         MPLD=0
         MPLP=0
         IGO=0

c------- Write order info for 'ALL', or if target species is reached
         IF (I.LE.NSGAS) IGO=1
         IF ((I.GT.NSGAS).AND.(I.LE.NSGAS+NSGRAIN)
     1                   .AND.(IDUST.GE.1)) IGO=2
         IF ((I.GT.NSGAS+NSGRAIN).AND.(IDUST.GE.3)) IGO=3

         IF (IGO.NE.0) THEN
            IF (IGO.EQ.1) THEN
               WRITE(NORD,310) I,SPEC(I),XN(I),IT,TIME/TYEAR,
     1                         DENS,AV,TEMP
  310          FORMAT (1X,I4,1X,'>',A8,1X,'XN=',1PE11.3E3,
     1                                 ', IT=',I5,
     2                                 ', t=',1PE10.3,
     3                              ' yr, D=',1PE10.3,
     4                                 ', Av=',0PF8.3,
     5                                 ', Tg=',0PF8.3)
            ENDIF
            IF (IGO.GE.2) THEN
               WRITE(NORD,311) I,SPEC(I),XN(I),IT,TIME/TYEAR,
     1                         DENS,AV,DTEMP
  311          FORMAT (1X,I4,1X,'>',A8,1X,'XN=',1PE11.3E3,
     1                                 ', IT=',I5,
     2                                 ', t=',1PE10.3,
     3                              ' yr, D=',1PE10.3,
     4                                 ', Av=',0PF8.3,
     5                                 ', Td=',0PF8.3)
            ENDIF

            WRITE(NORD,312) 
  312       FORMAT (80X,'FORM RATE (s-1)',2X,'DEST RATE (s-1)')

c --------- Cycle through reactions for species
            DO J=1,NRX(I)
               XXX=RMUL(J,I)*R(IRX(J,I))
c ------------ Find loss/gain rates for species
               DEST(J)=0.0D+0
               PROD(J)=0.0D+0
               IF (XXX.LT.0) THEN
                  MPLD=MPLD+1
                  DEST(MPLD)=XXX
                  PLACED(MPLD)=MPLD
                  RXND(MPLD)=J
               ENDIF
               IF (XXX.GT.0) THEN
                  MPLP=MPLP+1
                  PROD(MPLP)=XXX
                  PLACEP(MPLP)=MPLP
                  RXNP(MPLP)=J
               ENDIF
            ENDDO

c --------- Re-order formation reactions into most important first
            DO J=1,MPLP-1
               DO K=J+1,MPLP
                  JPLTEM=PLACEP(J)
                  KPLTEM=PLACEP(K)
                  IF (PROD(PLACEP(K)).GT.PROD(PLACEP(J))) THEN
                     PLACEP(K)=JPLTEM
                     PLACEP(J)=KPLTEM
                  ENDIF
               ENDDO
            ENDDO

c --------- Re-order destruction reactions into most important first
            DO J=1,MPLD-1
               DO K=J+1,MPLD
                  JPLTEM=PLACED(J)
                  KPLTEM=PLACED(K)
                  IF (DEST(PLACED(K)).LT.DEST(PLACED(J))) THEN
                     PLACED(K)=JPLTEM
                     PLACED(J)=KPLTEM
                  ENDIF
               ENDDO
            ENDDO

c --------- Write formation reactions (always write first 6)
            DO J=1,MPLP
               PPC(J)=100*(PROD(PLACEP(J))/DXDTP(I))
               IF ((PPC(J).GT.0.5D+00).OR.(J.LE.6)) THEN
                  WRITE(NORD,315) IRX( RXNP(PLACEP(J)) , I),
     1                  RSPEC(1,  IRX( RXNP(PLACEP(J)) , I) ),
     2                  RSPEC(2,  IRX( RXNP(PLACEP(J)) , I) ),
     3                 (RSPEC(K,  IRX( RXNP(PLACEP(J)) , I) ),K=4,7),
     4                  SYM2(     IRX( RXNP(PLACEP(J)) , I) ),
     5                  NINT(PPC(J)),PROD(PLACEP(J))
               ENDIF
            ENDDO
c --------- Write destruction reactions (always write first 6)
            DO J=1,MPLD
               DPC(J)=100*(DEST(PLACED(J))/DXDTN(I))
               IF ((DPC(J).GT.0.5D+00).OR.(J.LE.6)) THEN
                  WRITE(NORD,320) IRX( RXND(PLACED(J)) , I),
     1                  RSPEC(1,  IRX( RXND(PLACED(J)) , I) ),
     2                  RSPEC(2,  IRX( RXND(PLACED(J)) , I) ),
     3                 (RSPEC(K,  IRX( RXND(PLACED(J)) , I) ),K=4,7),
     4                  SYM2(     IRX( RXND(PLACED(J)) , I) ),
     5                 -NINT(DPC(J)),DEST(PLACED(J))
               ENDIF
            ENDDO
            WRITE(NORD,330) DXDTP(I)+DXDTN(I),DXDTP(I),DXDTN(I)
            WRITE(NORD,340)
         ENDIF
      ENDDO

  315 FORMAT (' *',I5,'*',2(1X,A8),' --> ',4(1X,A8),A4,2X,
     1        I4,'%',4X,1PE11.3E3)
  320 FORMAT (' *',I5,'*',2(1X,A8),' --> ',4(1X,A8),A4,2X,
     1        I4,'%',21X,1PE11.3E3)
  330 FORMAT (67X,1PE11.3E3,4X,1PE11.3E3,6X,1PE11.3E3)
  340 FORMAT (112('-'))

      RETURN 
      END 

c ======================================================================
c ======================================================================
      SUBROUTINE WRITENAME(NO)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'

      INTEGER NO

      WRITE (NO,*)
      WRITE (NO,5)
      WRITE (NO,10)
      WRITE (NO,5)
      WRITE (NO,20) VERS
      WRITE (NO,5)
      WRITE (NO,30) RFNAME
      WRITE (NO,5)
      WRITE (NO,*)

    5 FORMAT (10X,56('-'))

   10 FORMAT (12X,'_/_/_/_/_/_/_/          _/            _/',
     1       /12X,'     _/                              _/',
     2       /12X,'    _/      _/_/_/    _/   _/_/_/   _/  _/   _/_/_/',
     3       /12X,'   _/      _/    _/  _/  _/        _/  _/  _/',
     4       /12X,'  _/      _/        _/  _/        _/_/      _/_/_/',
     5       /12X,' _/      _/        _/  _/        _/  _/         _/',
     6       /12X,'_/      _/        _/    _/_/_/  _/    _/  _/_/_/')

   20 FORMAT (10X,'*Trainer for Interstellar Chemical ',
     1            'Kinetics Simulations*',
     2       /10X,A20)

   30 FORMAT (10X,A72)

      RETURN
      END

c ======================================================================
c ======================================================================

