c =========================================================================
c tricks.f, trx_shield.f: (c) R T Garrod, 2021-, excl. SPLINE, SPLINT
c =========================================================================

      SUBROUTINE INITSS
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      INCLUDE 'trx_header.f'
      REAL*8 CDTAB1(106),THETA1(106),DERIV1(106)
      REAL*8 CDTAB2(53),THETA2(53),DERIV2(53)
      REAL*8 CDTAB3(44),THETA3(44),DERIV3(44)
      REAL*8 CDTAB4(44),THETA4(44),DERIV4(44)
      COMMON/SSH2/CDTAB1,THETA1,DERIV1
      COMMON/SS1CO/CDTAB2,THETA2,DERIV2,CDTAB3,THETA3,DERIV3
      COMMON/SS2CO/CDTAB4,THETA4,DERIV4
      DATA N1/106/,N2/53/,N3/44/,N4/44/

      READ (NSSH,10)
      DO I=1,N1
         READ (NSSH,40) CDTAB1(I),THETA1(I)
         CDTAB1(I)=DLOG10(CDTAB1(I))
         THETA1(I)=DLOG10(THETA1(I))
      ENDDO
      READ (NSSH,20)
      DO I=1,N2
         READ (NSSH,40) CDTAB2(I),THETA2(I)
         CDTAB2(I)=DLOG10(CDTAB2(I))
         THETA2(I)=DLOG10(THETA2(I))
      ENDDO
      READ (NSSH,30)
      DO I=1,N3
         READ (NSSH,40) CDTAB3(I),THETA3(I)
         CDTAB3(I)=DLOG10(CDTAB3(I))
         THETA3(I)=DLOG10(THETA3(I))
      ENDDO
      READ (NSSH,30)
      DO I=1,N4
         READ (NSSH,40) CDTAB4(I),THETA4(I)
         CDTAB4(I)=DLOG10(CDTAB4(I))
         THETA4(I)=DLOG10(THETA4(I))
      ENDDO

      CALL SPLINE(CDTAB1,THETA1,N1,2.0D+30,2.0D+30,DERIV1)
      CALL SPLINE(CDTAB2,THETA2,N2,2.0D+30,2.0D+30,DERIV2)
      CALL SPLINE(CDTAB3,THETA3,N3,2.0D+30,2.0D+30,DERIV3)
      CALL SPLINE(CDTAB4,THETA4,N4,2.0D+30,2.0D+30,DERIV4)

   10 FORMAT (//////)
   20 FORMAT (/////)
   30 FORMAT (//)
   40 FORMAT (E10.3,2X,E10.3)

      RETURN
      END

c ======================================================================
c ======================================================================
      SUBROUTINE H2SHIELD
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      SAVE JLO1,JHI1
      INCLUDE 'trx_header.f'
      REAL*8 CDTAB1(106),THETA1(106),DERIV1(106)
      COMMON/SSH2/CDTAB1,THETA1,DERIV1
      DATA JLO1/0/,JHI1/0/,N1/106/

      IF (CDH2.LE.1.D-60) CD=-60.D0
      IF (CDH2.GT.1.D-60) CD=DLOG10(CDH2)

      CALL SPLINT(CDTAB1,THETA1,DERIV1,N1,CD,Y1,JLO1,JHI1)
      IF (CD.LE.CDTAB1(1)) Y1=0.0D+0
      IF (CD.GE.CDTAB1(N1)) Y1=THETA1(N1)

      XK(NRH2)=2.54D-11*(1.0D+1**Y1)*UVFAC

      RETURN
      END

c ======================================================================
c ======================================================================
      SUBROUTINE COSHIELD
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N)
      SAVE JLO2,JLO3,JLO4,JHI2,JHI3,JHI4
      INCLUDE 'trx_header.f'
      REAL*8 CDTAB2(53),THETA2(53),DERIV2(53)
      REAL*8 CDTAB3(44),THETA3(44),DERIV3(44)
      REAL*8 CDTAB4(44),THETA4(44),DERIV4(44)
      COMMON/SS1CO/CDTAB2,THETA2,DERIV2,CDTAB3,THETA3,DERIV3
      COMMON/SS2CO/CDTAB4,THETA4,DERIV4
      DATA JLO2/0/,JHI2/0/,JLO3/0/,JHI3/0/,JLO4/0/,JHI4/0/
      DATA N2/53/,N3/44/,N4/44/

      IF (CDCO.LE.1.D-60) CD2=-60.D0
      IF (CDCO.GT.1.D-60) CD2=DLOG10(CDCO)
      IF (CDH2.LE.1.D-60) CD3=-60.D0
      IF (CDH2.GT.1.D-60) CD3=DLOG10(CDH2)
      IF (AV.LE.1.D-60)   CD4=-60.D0
      IF (AV.GT.1.D-60)   CD4=DLOG10(AV)

      CALL SPLINT(CDTAB2,THETA2,DERIV2,N2,CD2,Y2,JLO2,JHI2)
      CALL SPLINT(CDTAB3,THETA3,DERIV3,N3,CD3,Y3,JLO3,JHI3)
      CALL SPLINT(CDTAB4,THETA4,DERIV4,N4,CD4,Y4,JLO4,JHI4)
      IF (CD2.LE.CDTAB2(1)) Y2=0.0D+0
      IF (CD3.LE.CDTAB3(2)) Y3=0.0D+0
      IF (CD4.LE.CDTAB4(3)) Y4=0.0D+0
      IF (CD2.GE.CDTAB2(N2)) Y2=THETA2(N2)
      IF (CD3.GE.CDTAB3(N3)) Y3=THETA3(N3)
      IF (CD4.GE.CDTAB4(N4)) Y4=THETA4(N4)

      XK(NRCO)=1.03D-10*(1.0D+1**Y2)*(1.0D+1**Y3)*(1.0D+1**Y4)*UVFAC

      RETURN
      END

c ======================================================================
c ======================================================================
      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)

c  calculate cubic spline for a set of points (x,y)

c  (cf. "numerical recipes" 3.3 : routine spline)
c  given arrays x and y of length n containing a tabulated function, 
c  i.e. y(i) = f(x(i)), with x(1) < x(2) < ... < x(n), and given values 
c  yp1 and ypn for the first derivative of the interpolating function at
c  points 1 and n, respectively, this routine returns an array y2 of 
c  length n which contains the second derivatives of the interpolating 
c  function at the tabulated points x(i). if yp1 and/or ypn are equal to
c  1.0e+30 or larger, the routine is signalled to set the corresponding
c  boundary condition for a natural spline, with zero second derivative 
c  on that boundary.
c  ---------------------------------------------------------------------
c  i/o parameter
c  i    x   : vector for independent variable x; dimension x(n)
c  i    y   : vector for x-dependent variable y; dimension y(n)
c  i    n   : dimension of vectors containing the tabulated function
c  i    yp1 : 1st derivative of the interpolating function at point 1
c  i    ypn : 1st derivative of the interpolating function at point n
c  o    y2  : 2nd derivative of the interpolating function 
c  ---------------------------------------------------------------------
c  i/o parameter type declaration
      INTEGER N
      REAL*8  X(N),Y(N),YP1,YPN,Y2(N)
c  program variables type declaration
      INTEGER I,K
      REAL*8  P,QN,SIG,U(N),UN
c  ---------------------------------------------------------------------
      IF (YP1 .GE. 1.0D30) THEN
           Y2(1) =  0.0D0
           U(1)  =  0.0D0
      ELSE
           Y2(1) = -0.5D0
           U(1)  = (3.0D0/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF   
      DO 100  I=2,N-1
           SIG   = (X(I)-X(I-1))/(X(I+1)-X(I-1))
           P     = SIG*Y2(I-1) + 2.0D0
           Y2(I) = (SIG-1.0D0)/P
           U(I)  = (6.0D0*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     &            /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
  100 CONTINUE
      IF (YPN .GE. 1.0D30) THEN
c  THE UPPER BOUNDARY CONDITION IS SET EITHER TO BE "NATURAL"
           QN = 0.0D0
           UN = 0.0D0
      ELSE
c  OR ELSE TO HAVE A SPECIFIED FIRST DERIVATIVE.
           QN = 0.5D0
           UN = (3.0D0/(X(N)-X(N-1))) *
     &          (YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N) = (UN-QN*U(N-1))/(QN*Y2(N-1)+1.0D0)
      DO 200  K=N-1,1,-1
           Y2(K)=Y2(K)*Y2(K+1)+U(K)
  200 CONTINUE

      RETURN
      END
      
c ======================================================================
c ======================================================================
      SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y,JLO,JHI)

c  cubic spline interpolation
   
c  (cf. "numerical recipes" 3.3 : routine splint, and 3.4. routine hunt)
c  given the arrays xa and ya of length n, which tabulate a function 
c  (with the xa(i)'s in order), and given the array y2a, which is the 
c  output of routine cubspl, and given a value x, this routine returns a
c  cubic-spline interpolated value y.
c  ---------------------------------------------------------------------
c  i/o parameters
c  i    xa  : vector for independent variable x; dimension xa(n)
c  i    ya  : vector for x-dependent variable y; dimension ya(n)
c  i    y2a : 2nd derivative of the interpolating function; dim. y2a(n)
c  i    n   : dimension of input vectors
c  i    x   : x value for which y is to be interpolated
c  o    y   : result of interpolation
c  ---------------------------------------------------------------------
c  i/o parameter type declaration
      INTEGER N
      REAL*8  X,XA(N),Y,YA(N),Y2A(N)
c  program variables type declaration
      INTEGER INC,JHI,JLO,JM
      REAL*8  H,A,B
      LOGICAL ASCND
c  ---------------------------------------------------------------------
      ASCND = XA(N).GT.XA(1)
      IF (JLO.LE.0 .OR. JLO.GT.N) THEN
         JLO = 0
         JHI = N+1
         GOTO 300
      ENDIF

      INC = 1
      IF (X.GE.XA(JLO) .EQV. ASCND) THEN
  100    JHI = JLO+INC
         IF (JHI.GT.N) THEN
            JHI = N+1
         ELSE IF (X.GE.XA(JHI) .EQV. ASCND) THEN
            JLO = JHI
            INC = INC+INC
            GOTO 100
         ENDIF
      ELSE
         JHI = JLO
  200    JLO = JHI-INC
         IF (JLO.LT.1) THEN
            JLO = 0
         ELSE IF (X.LT.XA(JLO) .EQV. ASCND) THEN
            JHI = JLO
            INC = INC+INC
            GOTO 200
         ENDIF
      ENDIF

  300 IF (JHI-JLO.NE.1) THEN
         JM = (JHI+JLO)/2
         IF (X.GT.XA(JM) .EQV. ASCND) THEN
            JLO = JM
         ELSE
            JHI = JM
         ENDIF
         GOTO 300
      ENDIF

      IF (JLO.EQ.0)  THEN
         JLO = 1
         JHI = 2
      ENDIF
      IF (JLO.EQ.N)  THEN
         JLO = N-1
         JHI = N
      ENDIF

c  CUBIC SPLINE POLYNOMIAL IS NOW EVALUATED.
      H = XA(JHI) - XA(JLO)
      A = (XA(JHI) - X) / H
      B = (X - XA(JLO)) / H
      Y = A*YA(JLO) + B*YA(JHI) +
     &   ((A**3-A)*Y2A(JLO) + (B**3-B)*Y2A(JHI)) * (H**2)/6.0D0

      RETURN
      END
